# Zenith

```
                         ______          _ _   _
                        |___  /         (_) | | |
                           / / ___ _ __  _| |_| |__
                          / / / _ \ '_ \| | __| '_ \
                         / /_|  __/ | | | | |_| | | |
                        /_____\___|_| |_|_|\__|_| |_|
                             Zcash Full Node CLI
```

[![Please don't upload to GitHub](https://nogithub.codeberg.page/badge.svg)](https://nogithub.codeberg.page) ![](https://img.shields.io/badge/License-MIT-green
)

Zenith is a wallet for the [Zebra](https://zfnd.org/zebra/) Zcash node . It has the following features:

- Creating new wallets.
- Creating new accounts.
- Creating new Unified Addresses.
- Listing transactions for specific addresses, decoding memos for easy reading.
- Copying addresses to the clipboard.
- Sending transactions with shielded memo support.
- Address Book for storing frequently used zcash addresses 

## Installation

- Install dependencies:
	- [Cabal](https://www.haskell.org/cabal/#install-upgrade)
	- [Zebra](https://zfnd.org/zebra/)
	- [Cargo](https://doc.rust-lang.org/cargo/getting-started/installation.html)
		- Install `cargo-c`:
			```shell
			cargo install cargo-c
			```
	- `xclip`
	- `libsecp256k1-dev`
	- `libxss-dev`
	- `libxrandr-dev`
- Clone the repository.

```bash
git clone https://git.vergara.tech/Vergara_Tech/zenith.git
cd zenith
git submodule init
git submodule update --remote
```

- Install using `cabal`:

```
cabal install
```

## Configuration

- Copy the sample `zenith.cfg` file to your home directory and update the values of your Zebra host and port.

## Usage

**Note:** This is beta software under active development. We recommend to use it on testnet. Zenith runs on the network Zebra is running, to use the testnet you need to configure your Zebra node to run on testnet.

From the location where the configured `zenith.cfg` file is placed, use `zenith cli` to start.

Zenith will attempt to connect to the node and start up, the app will guide you through the creation of the first wallet.

### Support

If you would have any questions or suggestions, please join us on our [Support channel](https://matrix.to/#/#support:vergara.tech)
